package org.wfc.omada.api.sitesetting.model;

import com.fasterxml.jackson.annotation.JsonProperty;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import javax.validation.Valid;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;
import java.util.Objects;

/**
 * VirtualWanConfig
 */
@ApiModel(description = "VirtualWanConfig")
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.SpringCodegen", date = "2024-12-04T11:32:19.054+08:00[Asia/Shanghai]")

public class VirtualWanConfigOpenApiVo   {
  @JsonProperty("name")
  private String name;

  @JsonProperty("physicalWanId")
  private String physicalWanId;

  @JsonProperty("virtualWanIpv4Setting")
  private VirtualWanIpv4SettingConfigOpenApiVo virtualWanIpv4Setting;

  @JsonProperty("virtualWanDsl")
  private VirtualWanDslOpenApiVo virtualWanDsl;

  @JsonProperty("wanPortMacSetting")
  private VirtualWanMacSettingOpenApiVo wanPortMacSetting;

  public VirtualWanConfigOpenApiVo name(String name) {
    this.name = name;
    return this;
  }

  /**
   * Virtual WAN name should contain 1 to 128 characters.
   * @return name
  */
  @ApiModelProperty(required = true, value = "Virtual WAN name should contain 1 to 128 characters.")
  @NotNull

@Pattern(regexp="^[^ \\+\\-\\@\\=]$|^[^ \\+\\-\\@\\=].{0,126}[^ ]$") 
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public VirtualWanConfigOpenApiVo physicalWanId(String physicalWanId) {
    this.physicalWanId = physicalWanId;
    return this;
  }

  /**
   * Physical WAN ID. Physical WAN ID can be obtained from 'Get internet basic info' interface. Only DSL WAN supports configuring virtual WAN. 
   * @return physicalWanId
  */
  @ApiModelProperty(required = true, value = "Physical WAN ID. Physical WAN ID can be obtained from 'Get internet basic info' interface. Only DSL WAN supports configuring virtual WAN. ")
  @NotNull


  public String getPhysicalWanId() {
    return physicalWanId;
  }

  public void setPhysicalWanId(String physicalWanId) {
    this.physicalWanId = physicalWanId;
  }

  public VirtualWanConfigOpenApiVo virtualWanIpv4Setting(VirtualWanIpv4SettingConfigOpenApiVo virtualWanIpv4Setting) {
    this.virtualWanIpv4Setting = virtualWanIpv4Setting;
    return this;
  }

  /**
   * Get virtualWanIpv4Setting
   * @return virtualWanIpv4Setting
  */
  @ApiModelProperty(required = true, value = "")
  @NotNull

  @Valid

  public VirtualWanIpv4SettingConfigOpenApiVo getVirtualWanIpv4Setting() {
    return virtualWanIpv4Setting;
  }

  public void setVirtualWanIpv4Setting(VirtualWanIpv4SettingConfigOpenApiVo virtualWanIpv4Setting) {
    this.virtualWanIpv4Setting = virtualWanIpv4Setting;
  }

  public VirtualWanConfigOpenApiVo virtualWanDsl(VirtualWanDslOpenApiVo virtualWanDsl) {
    this.virtualWanDsl = virtualWanDsl;
    return this;
  }

  /**
   * Get virtualWanDsl
   * @return virtualWanDsl
  */
  @ApiModelProperty(value = "")

  @Valid

  public VirtualWanDslOpenApiVo getVirtualWanDsl() {
    return virtualWanDsl;
  }

  public void setVirtualWanDsl(VirtualWanDslOpenApiVo virtualWanDsl) {
    this.virtualWanDsl = virtualWanDsl;
  }

  public VirtualWanConfigOpenApiVo wanPortMacSetting(VirtualWanMacSettingOpenApiVo wanPortMacSetting) {
    this.wanPortMacSetting = wanPortMacSetting;
    return this;
  }

  /**
   * Get wanPortMacSetting
   * @return wanPortMacSetting
  */
  @ApiModelProperty(value = "")

  @Valid

  public VirtualWanMacSettingOpenApiVo getWanPortMacSetting() {
    return wanPortMacSetting;
  }

  public void setWanPortMacSetting(VirtualWanMacSettingOpenApiVo wanPortMacSetting) {
    this.wanPortMacSetting = wanPortMacSetting;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    VirtualWanConfigOpenApiVo virtualWanConfigOpenApiVo = (VirtualWanConfigOpenApiVo) o;
    return Objects.equals(this.name, virtualWanConfigOpenApiVo.name) &&
        Objects.equals(this.physicalWanId, virtualWanConfigOpenApiVo.physicalWanId) &&
        Objects.equals(this.virtualWanIpv4Setting, virtualWanConfigOpenApiVo.virtualWanIpv4Setting) &&
        Objects.equals(this.virtualWanDsl, virtualWanConfigOpenApiVo.virtualWanDsl) &&
        Objects.equals(this.wanPortMacSetting, virtualWanConfigOpenApiVo.wanPortMacSetting);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, physicalWanId, virtualWanIpv4Setting, virtualWanDsl, wanPortMacSetting);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class VirtualWanConfigOpenApiVo {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    physicalWanId: ").append(toIndentedString(physicalWanId)).append("\n");
    sb.append("    virtualWanIpv4Setting: ").append(toIndentedString(virtualWanIpv4Setting)).append("\n");
    sb.append("    virtualWanDsl: ").append(toIndentedString(virtualWanDsl)).append("\n");
    sb.append("    wanPortMacSetting: ").append(toIndentedString(wanPortMacSetting)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
}

